<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
        <el-form-item label="市场名称" prop="marketNum">
          <el-input
            v-model="queryParams.marketNum"
            placeholder="请输入市场名称"
            clearable/>
        </el-form-item>
        <!--        <el-form-item label="排查日期" prop="timeRange">-->
        <!--          <el-date-picker-->
        <!--            v-model="queryParams.timeRange"-->
        <!--            type="daterange"-->
        <!--            value-format="yyyy-MM-dd"-->
        <!--            range-separator="至"-->
        <!--            start-placeholder="开始日期"-->
        <!--            end-placeholder="结束日期"-->
        <!--            :picker-options="pickerOptions"-->
        <!--          >-->
        <!--          </el-date-picker>-->
        <!--        </el-form-item>-->
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['baseInfo:bazaar:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDeleteAll"
            v-hasPermi="['baseInfo:bazaar:remove']"
          >批量删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
    </el-card>
    <br />
    <el-card>
      <el-table border stripe  v-loading="loading" ref="multipleTable" :data="disposalList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="市场编号" align="center" prop="marketNum" />
        <el-table-column label="市场名称" align="center" prop="marketName" />
        <el-table-column label="物流线" align="center" prop="lineName" />
        <el-table-column label="区域" align="center" prop="region" />
        <el-table-column label="价格类型" align="center" prop="priceType" />
        <el-table-column label="市场容量" align="center" prop="marketSize" />
        <el-table-column label="市场地址" align="center" prop="marketAddress" />
        <el-table-column label="业务员" align="center" prop="salesperson" />
        <el-table-column label="状态" align="center" prop="marketStatus" >
          <template slot-scope="scope">
            <el-tag v-if="scope.row.marketStatus === 1" type="success">启用</el-tag>
            <el-tag v-else-if="scope.row.marketStatus === 0" type="danger">停用</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center" prop="remark" />
        <el-table-column label="操作" width="180" align="center" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['baseInfo:bazaar:edit']"
              style="margin-right: 8px"
            >修改</el-button>
            <el-popconfirm
              v-hasPermi="['baseInfo:bazaar:remove']"
              :title="'确定要删除这条数据吗？'"
              @confirm="handleDelete(scope.row)"
            >
              <el-button
                size="mini"
                type="text"
                slot="reference"
                icon="el-icon-delete"
              >删除</el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>
    <!-- 添加或修改死淘处理方式对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="550px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" :disabled="isView" label-width="100px">
        <el-form-item label="市场编号" prop="marketNum">
          <el-input
            ref="marketNum"
            v-model="form.marketNum"
            placeholder="请输入市场编号"
            @keydown.enter.native="goNext($event, 'marketName')"
          />
        </el-form-item>
        <el-form-item label="市场名称" prop="marketName">
          <el-input
            ref="marketName"
            v-model="form.marketName"
            placeholder="请输入市场名称"
            @keydown.enter.native="goNext($event, 'lineNum')"
          />
        </el-form-item>
        <el-form-item label="物流线" prop="lineNum">
          <el-select
            style="width: 100%"
            ref="lineNum"
            filterable
            v-model="form.lineNum"
            @change="changeLine"
            placeholder="请选择物流线"
            @keydown.enter.native="goNext($event, 'region')"
          >
            <el-option v-for="(item, i) in lineList" :key="i" :value="item.lineNum" :label="item.lineName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="区域" prop="region">
          <el-select
            ref="region"
            style="width: 100%"
            filterable
            v-model="form.region"
            placeholder="请选择区域"
            @keydown.enter.native="goNext($event, 'priceType')"
          >
            <el-option v-for="(item, i) in areaList" :key="i" :value="item.salesTerritoryNum" :label="item.salesTerritoryName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="价格类型" prop="priceType">
          <el-select
            ref="priceType"
            style="width: 100%"
            filterable
            v-model="form.priceType"
            placeholder="请选择价格类型"
            @keydown.enter.native="goNext($event, 'marketSize')"
          >
            <el-option v-for="(item, i) in priceTypeList" :key="i" :value="item.priceTypeNum" :label="item.priceTypeName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="市场容量" prop="marketSize">
          <el-input
            ref="marketSize"
            v-model="form.marketSize"
            placeholder="请输入市场容量"
            @keydown.enter.native="goNext($event, 'marketAddress')"
          />
        </el-form-item>
        <el-form-item label="市场地址" prop="marketAddress">
          <el-input
            ref="marketAddress"
            v-model="form.marketAddress"
            placeholder="请输入市场地址"
            @keydown.enter.native="goNext($event, 'salesperson')"
          />
        </el-form-item>
        <el-form-item label="业务员" prop="salesperson">
          <el-select
            ref="salesperson"
            style="width: 100%"
            filterable
            v-model="form.salesperson"
            placeholder="请选择业务员"
            @keydown.enter.native="goNext($event, 'marketStatus')"
          >
            <el-option v-for="(item, i) in staffList" :key="i" :value="item.employeeNum" :label="item.employeeName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="状态" prop="marketStatus">
          <el-radio-group ref="marketStatus" v-model="form.marketStatus">
            <el-radio :label="1">启用</el-radio>
            <el-radio :label="0">停用</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input type="textarea" v-model="form.remark"  placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { getBazaarById, getBazaarPage, addBazaar, editBazaar, delBazaar } from "@/api/baseInfo/bazaar";
import { getLogisticsList } from "@/api/baseInfo/logistics";
import { getAreaList } from "@/api/baseInfo/area";
import { getFindByKey } from "@/utils";
import { getStaffList } from "@/api/baseInfo/staff";
import { getPriceList } from "@/api/baseInfo/price";
export default {
  name: "Bazaar",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      disposalList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        marketNum: null,
        timeRange: null,
        startTime: null,
        endTime: null,
      },
      pickerOptions: {
        disabledDate(time) {
          // 获取当前日期
          const today = new Date();
          today.setHours(0, 0, 0, 0); // 将时间设置为当天的 00:00:00

          // 禁用今天之后的日期
          return time.getTime() > today.getTime();
        }
      },
      // 表单参数
      form: {},
      rules: {
        marketNum: [{required: true, message: '请输入序号', trigger: 'blur'}],
        marketName: [{required: true, message: '请输入市场名称', trigger: 'blur'}],
        lineNum: [{required: true, message: '请选择物流线', trigger: 'change'}],
        region: [{required: true, message: '请选择区域', trigger: 'change'}],
        priceType: [{required: true, message: '请选择价格类型', trigger: 'change'}],
        marketSize: [{required: true, message: '请输入市场容量', trigger: 'blur'}],
        marketAddress: [{required: true, message: '请输入市场地址', trigger: 'blur'}],
        salesperson: [{required: true, message: '请选择业务员', trigger: 'change'}],
        marketStatus: [{required: true, message: '请选择状态', trigger: 'change'}],
      },
      lineList: [],
      areaList: [],
      staffList: [],
      priceTypeList: [],
    }
  },
  watch: {
    "queryParams.timeRange": {
      handler(newVal) {
        if (newVal) {
          this.queryParams.startTime = newVal[0]
          this.queryParams.endTime = newVal[1]
        } else {
          this.queryParams.startTime = null
          this.queryParams.endTime = null
        }
      },
      deep: true
    },
  },
  created() {
    this.getArea()
    this.getStaff()
    this.getLogistics()
    this.getPriceType()
    this.getList();
  },
  methods: {  
    /** 价格类型 **/
    getPriceType() {
      getPriceList({}).then(res => {
        /** 价格类型：只保留状态为“启用”的数据 */
        const list = res.data || []
        this.priceTypeList = list.filter(item => item.priceTypeStatus ===1)
      })
    },
    /** 员工管理(销售员) **/
    getStaff() {
      getStaffList({}).then(res => {
        let arr = []
        res.data.forEach(item => {
          if(item.employeeType === '3') {
            arr.push(item)
          }
        })
        this.staffList = arr
      })
    },
    /** 区域 **/
    getArea() {
      getAreaList({}).then(res => {
        this.areaList = res.data
      })
    },
    /** 物流线 **/
    getLogistics() {
      getLogisticsList({}).then(res => {
        this.lineList = res.data
      })
    },
    goNext(event, nextRef) {
      event.preventDefault();
      this.$refs[nextRef].focus();
    },
    changeLine(val) {
      let item = getFindByKey(this.lineList, val, 'lineNum')
      if(item) {
        this.form.lineName = item.lineName
      }
    },
    /** 查询检验项目列表 */
    getList() {
      getBazaarPage(this.queryParams).then(res => {
        this.disposalList = res.data.records;
        this.total = res.data.total;
        this.loading = false;
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      // this.resetForm("queryForm");
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
        marketNum: null,
        timeRange: null,
        startTime: null,
        endTime: null,
      }
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getBazaarById(params).then(res => {
        this.form = res.data;
        this.open = true;
        this.isView = false;
        this.title = "编辑"
      })
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getBazaarById(params).then(res => {
        this.form = res.data;
        this.open = true;
        this.isView = true;
        this.title = "查看"
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        marketNum: null,
        marketName: null,
        lineNum: null,
        lineName: null,
        region: null,
        priceType: null,
        marketSize: null,
        marketAddress: null,
        salesperson: null,
        marketStatus: 1,
        remark: null
      };
      this.resetForm("form");
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            // 编辑
            editBazaar(this.form).then(res => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            })
          } else {
            // 新增
            addBazaar(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id;
      let params = {
        ids: ids
      }
      delBazaar(params).then(res => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      })
    },
    /** 删除按钮操作 */
    handleDeleteAll() {
      const ids = this.ids;
      this.$modal.confirm('确定要删除这条数据吗？').then(() => {
        let params = {
          ids: ids.join(',')
        }
        delBazaar(params).then(res => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
          this.$refs.multipleTable.clearSelection();
        })
      })
    }
  }
}
</script>

<style scoped lang="scss">

</style>

